/**
 * <copyright>
 *
 * Copyright (c) 2006 Chaur G. Wu. All rights reserved. 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * </copyright>
 */

package net.sf.model4lang.boolscript;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see net.sf.model4lang.boolscript.BoolScriptFactory
 * @model kind="package"
 * @generated
 */
public interface BoolScriptPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "boolscript";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http:///net/sf/model4lang/boolscript/boolscript.ecore";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "net.sf.model4lang.boolscript";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	BoolScriptPackage eINSTANCE = net.sf.model4lang.boolscript.impl.BoolScriptPackageImpl.init();

	/**
	 * The meta object id for the '{@link net.sf.model4lang.boolscript.impl.BoolTermImpl <em>Bool Term</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.sf.model4lang.boolscript.impl.BoolTermImpl
	 * @see net.sf.model4lang.boolscript.impl.BoolScriptPackageImpl#getBoolTerm()
	 * @generated
	 */
	int BOOL_TERM = 0;

	/**
	 * The feature id for the '<em><b>Term Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOL_TERM__TERM_VALUE = 0;

	/**
	 * The number of structural features of the '<em>Bool Term</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOL_TERM_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link net.sf.model4lang.boolscript.impl.AndTermImpl <em>And Term</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.sf.model4lang.boolscript.impl.AndTermImpl
	 * @see net.sf.model4lang.boolscript.impl.BoolScriptPackageImpl#getAndTerm()
	 * @generated
	 */
	int AND_TERM = 1;

	/**
	 * The feature id for the '<em><b>Term Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND_TERM__TERM_VALUE = BOOL_TERM__TERM_VALUE;

	/**
	 * The feature id for the '<em><b>And Left Term</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND_TERM__AND_LEFT_TERM = BOOL_TERM_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>And Right Term</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND_TERM__AND_RIGHT_TERM = BOOL_TERM_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>And Term</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int AND_TERM_FEATURE_COUNT = BOOL_TERM_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link net.sf.model4lang.boolscript.impl.OrTermImpl <em>Or Term</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.sf.model4lang.boolscript.impl.OrTermImpl
	 * @see net.sf.model4lang.boolscript.impl.BoolScriptPackageImpl#getOrTerm()
	 * @generated
	 */
	int OR_TERM = 2;

	/**
	 * The feature id for the '<em><b>Term Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR_TERM__TERM_VALUE = BOOL_TERM__TERM_VALUE;

	/**
	 * The feature id for the '<em><b>Or Left Term</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR_TERM__OR_LEFT_TERM = BOOL_TERM_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Or Right Term</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR_TERM__OR_RIGHT_TERM = BOOL_TERM_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Or Term</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int OR_TERM_FEATURE_COUNT = BOOL_TERM_FEATURE_COUNT + 2;

	/**
	 * The meta object id for the '{@link net.sf.model4lang.boolscript.impl.BoolPackageImpl <em>Bool Package</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.sf.model4lang.boolscript.impl.BoolPackageImpl
	 * @see net.sf.model4lang.boolscript.impl.BoolScriptPackageImpl#getBoolPackage()
	 * @generated
	 */
	int BOOL_PACKAGE = 3;

	/**
	 * The feature id for the '<em><b>Terms</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOL_PACKAGE__TERMS = 0;

	/**
	 * The number of structural features of the '<em>Bool Package</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int BOOL_PACKAGE_FEATURE_COUNT = 1;

	/**
	 * The meta object id for the '{@link net.sf.model4lang.boolscript.impl.VarImpl <em>Var</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see net.sf.model4lang.boolscript.impl.VarImpl
	 * @see net.sf.model4lang.boolscript.impl.BoolScriptPackageImpl#getVar()
	 * @generated
	 */
	int VAR = 4;

	/**
	 * The feature id for the '<em><b>Term Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR__TERM_VALUE = BOOL_TERM__TERM_VALUE;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR__NAME = BOOL_TERM_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Var</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int VAR_FEATURE_COUNT = BOOL_TERM_FEATURE_COUNT + 1;


	/**
	 * Returns the meta object for class '{@link net.sf.model4lang.boolscript.BoolTerm <em>Bool Term</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Bool Term</em>'.
	 * @see net.sf.model4lang.boolscript.BoolTerm
	 * @generated
	 */
	EClass getBoolTerm();

	/**
	 * Returns the meta object for the attribute '{@link net.sf.model4lang.boolscript.BoolTerm#isTermValue <em>Term Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Term Value</em>'.
	 * @see net.sf.model4lang.boolscript.BoolTerm#isTermValue()
	 * @see #getBoolTerm()
	 * @generated
	 */
	EAttribute getBoolTerm_TermValue();

	/**
	 * Returns the meta object for class '{@link net.sf.model4lang.boolscript.AndTerm <em>And Term</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>And Term</em>'.
	 * @see net.sf.model4lang.boolscript.AndTerm
	 * @generated
	 */
	EClass getAndTerm();

	/**
	 * Returns the meta object for the reference '{@link net.sf.model4lang.boolscript.AndTerm#getAndLeftTerm <em>And Left Term</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>And Left Term</em>'.
	 * @see net.sf.model4lang.boolscript.AndTerm#getAndLeftTerm()
	 * @see #getAndTerm()
	 * @generated
	 */
	EReference getAndTerm_AndLeftTerm();

	/**
	 * Returns the meta object for the reference '{@link net.sf.model4lang.boolscript.AndTerm#getAndRightTerm <em>And Right Term</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>And Right Term</em>'.
	 * @see net.sf.model4lang.boolscript.AndTerm#getAndRightTerm()
	 * @see #getAndTerm()
	 * @generated
	 */
	EReference getAndTerm_AndRightTerm();

	/**
	 * Returns the meta object for class '{@link net.sf.model4lang.boolscript.OrTerm <em>Or Term</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Or Term</em>'.
	 * @see net.sf.model4lang.boolscript.OrTerm
	 * @generated
	 */
	EClass getOrTerm();

	/**
	 * Returns the meta object for the reference '{@link net.sf.model4lang.boolscript.OrTerm#getOrLeftTerm <em>Or Left Term</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Or Left Term</em>'.
	 * @see net.sf.model4lang.boolscript.OrTerm#getOrLeftTerm()
	 * @see #getOrTerm()
	 * @generated
	 */
	EReference getOrTerm_OrLeftTerm();

	/**
	 * Returns the meta object for the reference '{@link net.sf.model4lang.boolscript.OrTerm#getOrRightTerm <em>Or Right Term</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Or Right Term</em>'.
	 * @see net.sf.model4lang.boolscript.OrTerm#getOrRightTerm()
	 * @see #getOrTerm()
	 * @generated
	 */
	EReference getOrTerm_OrRightTerm();

	/**
	 * Returns the meta object for class '{@link net.sf.model4lang.boolscript.BoolPackage <em>Bool Package</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Bool Package</em>'.
	 * @see net.sf.model4lang.boolscript.BoolPackage
	 * @generated
	 */
	EClass getBoolPackage();

	/**
	 * Returns the meta object for the containment reference list '{@link net.sf.model4lang.boolscript.BoolPackage#getTerms <em>Terms</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Terms</em>'.
	 * @see net.sf.model4lang.boolscript.BoolPackage#getTerms()
	 * @see #getBoolPackage()
	 * @generated
	 */
	EReference getBoolPackage_Terms();

	/**
	 * Returns the meta object for class '{@link net.sf.model4lang.boolscript.Var <em>Var</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Var</em>'.
	 * @see net.sf.model4lang.boolscript.Var
	 * @generated
	 */
	EClass getVar();

	/**
	 * Returns the meta object for the attribute '{@link net.sf.model4lang.boolscript.Var#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see net.sf.model4lang.boolscript.Var#getName()
	 * @see #getVar()
	 * @generated
	 */
	EAttribute getVar_Name();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	BoolScriptFactory getBoolScriptFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link net.sf.model4lang.boolscript.impl.BoolTermImpl <em>Bool Term</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.sf.model4lang.boolscript.impl.BoolTermImpl
		 * @see net.sf.model4lang.boolscript.impl.BoolScriptPackageImpl#getBoolTerm()
		 * @generated
		 */
		EClass BOOL_TERM = eINSTANCE.getBoolTerm();

		/**
		 * The meta object literal for the '<em><b>Term Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute BOOL_TERM__TERM_VALUE = eINSTANCE.getBoolTerm_TermValue();

		/**
		 * The meta object literal for the '{@link net.sf.model4lang.boolscript.impl.AndTermImpl <em>And Term</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.sf.model4lang.boolscript.impl.AndTermImpl
		 * @see net.sf.model4lang.boolscript.impl.BoolScriptPackageImpl#getAndTerm()
		 * @generated
		 */
		EClass AND_TERM = eINSTANCE.getAndTerm();

		/**
		 * The meta object literal for the '<em><b>And Left Term</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference AND_TERM__AND_LEFT_TERM = eINSTANCE.getAndTerm_AndLeftTerm();

		/**
		 * The meta object literal for the '<em><b>And Right Term</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference AND_TERM__AND_RIGHT_TERM = eINSTANCE.getAndTerm_AndRightTerm();

		/**
		 * The meta object literal for the '{@link net.sf.model4lang.boolscript.impl.OrTermImpl <em>Or Term</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.sf.model4lang.boolscript.impl.OrTermImpl
		 * @see net.sf.model4lang.boolscript.impl.BoolScriptPackageImpl#getOrTerm()
		 * @generated
		 */
		EClass OR_TERM = eINSTANCE.getOrTerm();

		/**
		 * The meta object literal for the '<em><b>Or Left Term</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OR_TERM__OR_LEFT_TERM = eINSTANCE.getOrTerm_OrLeftTerm();

		/**
		 * The meta object literal for the '<em><b>Or Right Term</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference OR_TERM__OR_RIGHT_TERM = eINSTANCE.getOrTerm_OrRightTerm();

		/**
		 * The meta object literal for the '{@link net.sf.model4lang.boolscript.impl.BoolPackageImpl <em>Bool Package</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.sf.model4lang.boolscript.impl.BoolPackageImpl
		 * @see net.sf.model4lang.boolscript.impl.BoolScriptPackageImpl#getBoolPackage()
		 * @generated
		 */
		EClass BOOL_PACKAGE = eINSTANCE.getBoolPackage();

		/**
		 * The meta object literal for the '<em><b>Terms</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference BOOL_PACKAGE__TERMS = eINSTANCE.getBoolPackage_Terms();

		/**
		 * The meta object literal for the '{@link net.sf.model4lang.boolscript.impl.VarImpl <em>Var</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see net.sf.model4lang.boolscript.impl.VarImpl
		 * @see net.sf.model4lang.boolscript.impl.BoolScriptPackageImpl#getVar()
		 * @generated
		 */
		EClass VAR = eINSTANCE.getVar();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute VAR__NAME = eINSTANCE.getVar_Name();

	}

} //BoolScriptPackage
