/**
 * <copyright>
 *
 * Copyright (c) 2006 Chaur G. Wu. All rights reserved. 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * </copyright>
 */

package net.sf.model4lang.boolscript.engine;
import java.util.List;
import java.util.ArrayList;

import javax.script.ScriptEngine;

public class BoolScriptEngineFactory implements javax.script.ScriptEngineFactory {

	/* (non-Javadoc)
	 * @see javax.script.ScriptEngineFactory#getEngineName()
	 */
	public String getEngineName() {
		return "Bool Script Engine";
	}

	/* (non-Javadoc)
	 * @see javax.script.ScriptEngineFactory#getEngineVersion()
	 */
	public String getEngineVersion() {
		return "1.0.0";
	}

	/* (non-Javadoc)
	 * @see javax.script.ScriptEngineFactory#getExtensions()
	 */
	public List getExtensions() {
		ArrayList<String> extList = new ArrayList<String>();
		extList.add("bool");
		return extList;
	}

	/* (non-Javadoc)
	 * @see javax.script.ScriptEngineFactory#getLanguageName()
	 */
	public String getLanguageName() {
		return "Bool Script Language";
	}

	/* (non-Javadoc)
	 * @see javax.script.ScriptEngineFactory#getLanguageVersion()
	 */
	public String getLanguageVersion() {
		return "1.0.0";
	}

	/* (non-Javadoc)
	 * @see javax.script.ScriptEngineFactory#getMethodCallSyntax(java.lang.String, java.lang.String, java.lang.String[])
	 */
	public String getMethodCallSyntax(String obj, String m, String[] args) {
		String callSyntax = obj;
		callSyntax += "." + m + "(";
		for (int i = 0; i < args.length; i++) {
			callSyntax += args[i];
			if (i < args.length - 2) callSyntax += ", ";
		}
		callSyntax += ")";
		return callSyntax;
	}

	/* (non-Javadoc)
	 * @see javax.script.ScriptEngineFactory#getMimeTypes()
	 */
	public List getMimeTypes() {
		ArrayList<String> extList = new ArrayList<String>();
		extList.add("code/bool");
		return extList;
	}

	/* (non-Javadoc)
	 * @see javax.script.ScriptEngineFactory#getNames()
	 */
	public List getNames() {
		ArrayList<String> extList = new ArrayList<String>();
		extList.add("bool script");
		return extList;
	}

	/* (non-Javadoc)
	 * @see javax.script.ScriptEngineFactory#getOutputStatement(java.lang.String)
	 */
	public String getOutputStatement(String toDisplay) {
		return "System.out.print(" + toDisplay + ")";
	}

	/* (non-Javadoc)
	 * @see javax.script.ScriptEngineFactory#getParameter(java.lang.String)
	 */
	public Object getParameter(String key) {
		if (key == ScriptEngine.ENGINE)
			return this.getEngineName();
		else if (key == ScriptEngine.ENGINE_VERSION)
			return this.getEngineVersion();
		else if (key == ScriptEngine.NAME)
			return this.getNames();
		else if (key == ScriptEngine.LANGUAGE)
			return this.getLanguageName();
		else if (key == ScriptEngine.LANGUAGE_VERSION)
			return this.getLanguageVersion();
		else
			return null;
	}

	/* (non-Javadoc)
	 * @see javax.script.ScriptEngineFactory#getProgram(java.lang.String[])
	 */
	public String getProgram(String[] statements) {
		return "";
	}

	/* (non-Javadoc)
	 * @see javax.script.ScriptEngineFactory#getScriptEngine()
	 */
	public ScriptEngine getScriptEngine() {
		return new BoolScriptEngine();
	}

}
