/**
 * <copyright>
 *
 * Copyright (c) 2006 Chaur G. Wu. All rights reserved. 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * </copyright>
 */

package net.sf.model4lang.boolscript.engine;

import java.io.Reader;

import javax.script.ScriptEngine;
import javax.script.http.HttpScriptContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.script.ScriptException;
import javax.script.SimpleBindings;
import javax.script.ScriptContext;

public class BoolScriptServlet extends GenericHttpScriptServlet {

	private HttpScriptContext ctx = null;
	//private BoolScriptEngine engine = null;
	
	/* (non-Javadoc)
	 * @see javax.script.http.HttpScriptServlet#getContext(javax.servlet.http.HttpServletRequest, javax.servlet.http.HttpServletResponse)
	 */
	@Override
	public HttpScriptContext getContext(HttpServletRequest request, HttpServletResponse response) throws ServletException {
		if (ctx == null)
			ctx = new SimpleHttpScriptContext();
		
		ctx.initialize(this, request, response);
		return ctx;
	}

	/* (non-Javadoc)
	 * @see javax.script.http.HttpScriptServlet#getEngine(javax.servlet.http.HttpServletRequest)
	 */
	@Override
	public ScriptEngine getEngine(HttpServletRequest arg0) {
		ScriptEngine engine = new BoolScriptEngine();
		engine.setBindings(new SimpleBindings(), ScriptContext.GLOBAL_SCOPE);
		engine.setBindings(new SimpleBindings(), ScriptContext.ENGINE_SCOPE);
		return engine;
	}

	/* (non-Javadoc)
	 * @see javax.script.http.HttpScriptServlet#releaseEngine(javax.script.ScriptEngine)
	 */
	@Override
	public void releaseEngine(ScriptEngine arg0) {
		// TODO Auto-generated method stub
		
	}

	/* (non-Javadoc)
	 * @see net.sf.model4lang.boolscript.engine.GenericHttpScriptServlet#runScript(javax.script.ScriptEngine, java.io.Reader, javax.script.http.HttpScriptContext)
	 */
	@Override
	public Object runScript(ScriptEngine engine, Reader reader, HttpScriptContext ctxt) throws ScriptException {
		return engine.eval(reader, ctxt);
	}

}
