/**
 * <copyright>
 *
 * Copyright (c) 2006 Chaur G. Wu. All rights reserved. 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * </copyright>
 */

package net.sf.model4lang.boolscript.engine;

import javax.script.*;
import javax.script.http.*;

public class SimpleHttpScriptContext extends GenericHttpScriptContext {
	
	protected Bindings engineBindings;
	protected Bindings globalBindings;

	public SimpleHttpScriptContext() {
		super();
		engineBindings = new SimpleBindings();
		globalBindings = null;
	}

	public void setBindings(Bindings bindings, int scope) {
		switch (scope) {
		case ENGINE_SCOPE:
			engineBindings = bindings;
			break;
		case GLOBAL_SCOPE:
			globalBindings = bindings;
			break;
		default:
			throw new IllegalArgumentException("parameter scope has an invalid value.");
		}
	}

	public Bindings getBindings(int scope) {
		switch (scope) {
		case ENGINE_SCOPE:
			return engineBindings;
		case GLOBAL_SCOPE:
			return globalBindings;
		default:
			throw new IllegalArgumentException("parameter scope has an invalid value.");
		}
	}

}
