/**
 * <copyright>
 *
 * Copyright (c) 2006 Chaur G. Wu. All rights reserved. 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * </copyright>
 */

package net.sf.model4lang.javacompiler;

import java.io.IOException;
import java.io.OutputStream;
import java.io.ByteArrayOutputStream;

public class ByteArrayOutputJavaFileObject  extends SimpleJavaFileObject {

	private ByteArrayOutputStream out;
	
	public ByteArrayOutputJavaFileObject(String className) {
		super(className, Kind.CLASS);
		out = new ByteArrayOutputStream();
	}

	/* (non-Javadoc)
	 * @see net.sf.model4lang.boolscript.engine.SimpleJavaFileObject#openOutputStream()
	 */
	@Override
	public OutputStream openOutputStream() throws IOException, IllegalStateException, UnsupportedOperationException {
		return out;
	}
}
