/**
 * <copyright>
 *
 * Copyright (c) 2006 Chaur G. Wu. All rights reserved. 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2 as 
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 *
 * </copyright>
 */

package net.sf.model4lang.javacompiler;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.Reader;
import java.io.Writer;
import java.net.URI;
import java.net.URISyntaxException;
import javax.tools.JavaFileObject;

public class SimpleJavaFileObject implements JavaFileObject {
    private String name;
    private Kind kind;
	
    public SimpleJavaFileObject(String name, Kind kind) {
        this.name = name;
        this.kind = kind;
    }
    
    /* (non-Javadoc)
	 * @see javax.tools.JavaFileObject#delete()
	 */
	public boolean delete() {
		return false;
	}
	/* (non-Javadoc)
	 * @see javax.tools.JavaFileObject#getCharContent(boolean)
	 */
	public CharSequence getCharContent(boolean ignoreEncodingErrors) throws IOException, IllegalStateException, UnsupportedOperationException {
		// TODO Auto-generated method stub
		return null;
	}
	/* (non-Javadoc)
	 * @see javax.tools.JavaFileObject#getKind()
	 */
	public Kind getKind() {
		return this.kind;
	}
	/* (non-Javadoc)
	 * @see javax.tools.JavaFileObject#getName()
	 */
	public String getName() {
		return this.name;
	}
	/* (non-Javadoc)
	 * @see javax.tools.JavaFileObject#getNameWithoutExtension()
	 */
	public String getNameWithoutExtension() {
		return this.name;
	}
	/* (non-Javadoc)
	 * @see javax.tools.JavaFileObject#getPath()
	 */
	public String getPath() {
		return getName();
	}
	/* (non-Javadoc)
	 * @see javax.tools.JavaFileObject#lastModified()
	 */
	public long lastModified() {
		// TODO Auto-generated method stub
		return 0;
	}
	/* (non-Javadoc)
	 * @see javax.tools.JavaFileObject#lengthInBytes()
	 */
	public long lengthInBytes() {
		// TODO Auto-generated method stub
		return 0;
	}
	/* (non-Javadoc)
	 * @see javax.tools.JavaFileObject#matches(java.lang.String, javax.tools.JavaFileObject.Kind)
	 */
	public boolean matches(String simpleName, Kind kind) {
		if (this.kind == kind && name.equals(simpleName))
        	return true;
        else
        	return false;
	}
	
	/* (non-Javadoc)
	 * @see javax.tools.JavaFileObject#openInputStream()
	 */
	public InputStream openInputStream() throws IOException, IllegalStateException, UnsupportedOperationException {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see javax.tools.JavaFileObject#openOutputStream()
	 */
	public OutputStream openOutputStream() throws IOException, IllegalStateException, UnsupportedOperationException {
		// TODO Auto-generated method stub
		return null;
	}

	/* (non-Javadoc)
	 * @see javax.tools.JavaFileObject#openWriter()
	 */
	public Writer openWriter() throws IOException, IllegalStateException, UnsupportedOperationException {
		// TODO Auto-generated method stub
		return null;
	}

	public boolean isNameCompatible(String simpleName, Kind kind) {
		// TODO Auto-generated method stub
		return false;
	}

	public long getLastModified() {
		// TODO Auto-generated method stub
		return 0;
	}

	public Reader openReader(boolean ignoreEncodingErrors) throws IOException {
		// TODO Auto-generated method stub
		return null;
	}

	public URI toUri() {
		try {
			return new URI("file", "", "/" + getName().replace('.', '/'), null);
		}
		catch (URISyntaxException e){
			System.out.println("URI syntax exception: " + e.getMessage());
			return null;
		}
	}

}

